#ifndef EFL_GENERATED_ECORE_JOB_HH
#define EFL_GENERATED_ECORE_JOB_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_job.eo.h"
}

#include <Ecore.h>

namespace ecore { 

struct job
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit job(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit job(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   job(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : job(_c0(_p))
   {}

   /// @param func 
   /// @param data 
   ///
   template <typename F>
   job(F && func_, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : job(_c1(std::forward<F>(func_), _p))
   {}

   /// @brief Copy Constructor.
   ///
   job(job const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~job() {}

   static Eo_Class const* _eo_class()
   {
      return(ECORE_JOB_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_JOB_CLASS, _p._eo_raw, eo_constructor());
   }

   template <typename F>
   static Eo* _c1(F && func_, efl::eo::parent_type _p)
   {
      typedef typename std::remove_reference<F>::type function_type;
function_type* _tmp_f = new F(std::forward<F>(func_));
      return eo_add_custom(ECORE_JOB_CLASS, _p._eo_raw, ecore_job_constructor(efl::eolian::get_callback<Ecore_Cb, function_type>(), _tmp_f));
   }

};
} 

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ecore::job >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ecore::job >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<ecore::job>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ecore::job >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<ecore::job, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ecore::job >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<ecore::job, ::std::tuple<Ecore_Cb, const void *> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::ecore_job_constructor(::efl::eolian::to_c(args.get<0>()), ::efl::eolian::to_c(args.get<1>())));
}

inline void
call_constructor(tag< ecore::job >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<ecore::job, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ecore::job>
{
   template <typename U>
   struct type
   {
      operator ecore::job() const
      {
         return ecore::job(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<ecore::job>)
{
   return (ECORE_JOB_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_JOB_HH

